function analytical_solution = advection_equation_analytical(fom_rom, discretization)
    
    % Builds up the analytical solution for the advection equation based on the parameters
    % in the structures fom_rom and discretization.
    
    space = discretization.space.dx * (1:discretization.space.n_steps);
    time = discretization.time.dt * (0:1:discretization.time.n_steps-1);
    
    grid = repmat(space', 1, discretization.time.n_steps) - repmat(fom_rom.parameter.c * time, discretization.space.n_steps, 1);
    
    grid = mod(grid, discretization.space.length);
    
    analytical_solution = fom_rom.initial_condition(grid, discretization.space.length);
    
end
