function next = implicit_trapezoid(t, dt, right_hand_side, current)

    % Implicit trapezoidal rule
    start = right_hand_side(t, current);
    
    f = @(intermediate_step) (right_hand_side(t + dt, current + (dt/2)*(start + intermediate_step)) - intermediate_step);
    intermediate_step = fsolve(f, start);

    next = current + (dt/2)*(start + intermediate_step);

end
