function relative_error = relative_L2_norm(snapshot_matrix, difference)

    % Computes the relative error in L2 norm under the assumption of periodic boundary conditions.
    % difference equals: approximation - snapshot_matrix
    
    abs_error_snapshot = 0.5 * (snapshot_matrix(:,1)' * snapshot_matrix(:,1) + snapshot_matrix(:,end)' * snapshot_matrix(:,end));
    
    abs_error_difference = 0.5 * (difference(:,1)' * difference(:,1) + difference(:,end)' * difference(:,end));
    
    for i = 2:size(snapshot_matrix, 2)-1
        abs_error_snapshot = abs_error_snapshot + snapshot_matrix(:,i)'*snapshot_matrix(:,i);
        abs_error_difference = abs_error_difference + difference(:,i)'*difference(:,i);
    end
    
    relative_error = sqrt(abs_error_difference / abs_error_snapshot);
    
end
