method = {'shifted POD r = 7', 'POD r = 7', 'POD r = 32'};
stage = {'relative offline error', 'relative online error'};

offline_errors = [relative_L2_offline_error, pod_relative_L2_offline_error_7, pod_relative_L2_offline_error_32];

online_errors = [relative_L2_online_error, pod_relative_L2_online_error_7, pod_relative_L2_online_error_32];

Table = table(offline_errors', online_errors', 'RowNames', method, 'VariableNames', stage);

disp(Table);

% Plot the surface plots

% FOM
space = discretization.space.dx * (1:discretization.space.n_steps);
time = discretization.time.dt * (0:1:discretization.time.n_steps-1);
[space_grid, time_grid] = ndgrid(space, time);
figure;
surf(space_grid, time_grid, snapshot_matrix{1});
xlabel('space');
ylabel('time');
title('FOM $\mu = 0.002$', 'Interpreter', 'latex');

% Absolute POD error with 7 modes
figure;
surf(space_grid, time_grid, abs(snapshot_matrix{1} - pod_solution_7{1}));
xlabel('space');
ylabel('time');
title('POD absolute error 7 modes');

% Absolute POD error with 32 modes
figure;
surf(space_grid, time_grid, abs(snapshot_matrix{1} - pod_solution_32{1}));
xlabel('space');
ylabel('time');
title('POD absolute error 32 modes');

% Absolute shifted POD error with 7 modes
figure;
surf(space_grid, time_grid, abs(snapshot_matrix{1} - shifted_pod_solution{1}));
xlabel('space');
ylabel('time');
title('Shifted POD absolute error 7 modes');

% Plot path
figure;
p = reduced_state_matrix{1}(end,:);
plot(time, p, 'DisplayName', 'p(t)');
hold on;
plot(time, linspace(p(1),-0.47, length(time)), 'DisplayName', 'linear');
xlabel('time');
legend();
title('Path');
hold off;

clear method;
clear stage;
clear offline_errors;
clear online_errors;
clear space;
clear time;
clear space_grid;
clear time_grid;
clear p;
