% Create Table for time steps

method = {'FOM', 'POD', '%pod', 'shifted POD', '%rom'};
solver = {'ode45', 'ode23'};

l1 = length(t_ode45{1});
l2 = length(t_ode45_pod{1});
l3 = length(t_ode45_rom{1});

l4 = length(t_ode23{1});
l5 = length(t_ode23_pod{1});
l6 = length(t_ode23_rom{1});

ode45_values = [l1, l2, 100*(l2/l1), l3, 100*(l3/l1)];
ode23_values = [l4, l5, 100*(l5/l4), l6, 100*(l6/l4)];

Table = table(ode45_values', ode23_values', 'RowNames', method, 'VariableNames', solver);

disp(Table);

% plot for ode45

figure;
plot(t_ode45{1}, 1:l1, 'ob', 'DisplayName', 'FOM');
hold on;
plot(t_ode45_pod{1}, 1:l2, 'sg', 'DisplayName', 'POD');
plot(t_ode45_rom{1}, 1:l3, 'dr', 'DisplayName', 'shifted POD');
xlabel('t');
ylabel('number of time steps');
legend();
title('ode45');
hold off;

% plot for ode23

figure;
plot(t_ode23{1}, 1:l4, 'ob', 'DisplayName', 'FOM');
hold on;
plot(t_ode23_pod{1}, 1:l5, 'sg', 'DisplayName', 'POD');
plot(t_ode23_rom{1}, 1:l6, 'dr', 'DisplayName', 'shifted POD');
xlabel('t');
ylabel('number of time steps');
legend();
title('ode23');
hold off;

% clear
clear method;
clear solver;
clear l1 l2 l3 l4 l5 l6;
clear ode45_values ode23_values;
