function shifted_POD_system = multi_shift_reduce_and_subtract(discretization, shifted_POD_system, snapshot_matrix, n_modes)  

sz = size(snapshot_matrix);
n_steps_space_per_var = sz(1);
n_vars = sz(end-1);
n_steps_space = n_vars * n_steps_space_per_var;
n_steps_time = discretization.time.n_steps;
n_subspaces = shifted_POD_system.n_subspaces; 
n_rows = prod(n_steps_space_per_var) * n_vars;

shifted_POD_system.U = cell(n_subspaces, 1);    
shifted_POD_system.V = cell(n_subspaces, 1);    
shifted_POD_system.S = cell(n_subspaces, 1);

    for i = 1:n_subspaces
        shifted_snapshot_matrix = shift_matrix(shifted_POD_system.shift_matrices{i}, snapshot_matrix, 1);
        
        shifted_snapshot_matrix = reshape(shifted_snapshot_matrix, n_rows, n_steps_time);
        
        [shifted_POD_system.U{i}, S, shifted_POD_system.V{i}] = svds(shifted_snapshot_matrix, n_modes(i));
        
        shifted_POD_system.S{i} = sparse(S); 
        co_moving_subspace = reshape(shifted_POD_system.U{i} * shifted_POD_system.S{i} * shifted_POD_system.V{i}', n_steps_space, n_vars, n_steps_time);
        
        co_moving_subspace_shifted_back = shift_matrix(shifted_POD_system.shift_matrices{i}, co_moving_subspace, 1, true);
        
        snapshot_matrix = snapshot_matrix - co_moving_subspace_shifted_back;
    end

end
