function snapshot_matrix_approximation = additive_subspace_combination(snapshot_matrix, discretization, shifted_POD_system, n_vars)   

% This function builds the approximation of the original snapshotMatrix via the determined modes. The approximation is build by applying the inverse transformation to every comoving frame and summing up.

n_steps_space_per_var = discretization.space.n_steps;
sz = size(snapshot_matrix);
n_steps_time = sz(end);

snapshot_matrix_approximation = zeros(n_steps_space_per_var, n_vars, n_steps_time);

    for i = 1:shifted_POD_system.n_subspaces
        
        co_moving_subspace = shifted_POD_system.U{i} * shifted_POD_system.S{i} * shifted_POD_system.V{i}';
        
        co_moving_subspace = reshape(co_moving_subspace, n_steps_space_per_var, n_vars, n_steps_time);
        
        shift_matrices = shifted_POD_system.shift_matrices{i};
        
        co_moving_subspace_shifted_back = shift_matrix(shift_matrices, co_moving_subspace, 1, true);
        
        snapshot_matrix_approximation = snapshot_matrix_approximation + co_moving_subspace_shifted_back;

    end

end
